#!/usr/bin/ruby
require 'digest/md5'

class FileInfo
  def initialize(name, size, digest, host, port)
    @name, @size, @digest = name, size, digest
    @host, @port = host, port
  end
  
  # filename -> FileInfo
  def self.create(name)
    path = $upload_dir + name
    if File.exist?(path)
      md5 = Digest::MD5.new
      File.open(path, "rb") {|f|
        while data = f.read(65536) do
          md5 << data
        end
      }
      digest = md5.hexdigest
      size = File.size(path)
      new(name, size, digest, $host, $port)
    else
      return nil
    end
  end
  
  # FileInfo -> String
  def to_string
    "#{@name}//#{@size}//#{@digest}//#{@host}//#{@port}"
  end
  
  def ==(other)
    return false if @digest != other.digest
    return false if @host != other.host
    return false if @port != other.port
    return true
  end
  
  def eql?(other)
    # t@CύX΍
    return false if @name != other.name
    return self == other
  end
  
  def <=>(other)
    return @name <=> other.name unless @name == other.name
    return @size <=> other.size
  end
  
  def hash
    # 31悶̂nbV֐̒΂炵
    hash = @name.hash
    hash = @digest.hash + hash * 31
    hash = @host.hash + hash * 31
    hash = @port.hash + hash * 31
  end
  
  attr_reader :name, :size, :digest, :host, :port
end

class String
  # String -> FileInfo
  def to_info
    array = split('//')
    name, size, digest = array[0], array[1].to_i, array[2]
    host, port = array[3], array[4].to_i
    FileInfo.new(name, size, digest, host, port)
  end
end

# Ȏdl˂΂̂
begin
  File::BINARY
rescue
  class File
    BINARY = 0
  end
end
